/*********************************************************************
 * jyudesk -- main program
 * $Id: ask_passwd.C,v 1.1 1998/04/12 14:36:21 tjko Exp $
 *
 * Copyright (c) 1998  Timo Kokkonen <tjko@iki.fi>
 *
 *
 * This file may be copied under the terms and conditions 
 * of the GNU General Public License, as published by the Free
 * Software Foundation (Cambridge, Massachusetts).
 */

#include <stdlib.h>
#include <string.h>
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Input.H>


static char *rcsid = "$Id: ask_passwd.C,v 1.1 1998/04/12 14:36:21 tjko Exp $";


char *ask_passwd()
{
  if (rcsid);

  Fl_Window *w;
  Fl_Input *i;
  Fl_Return_Button *b1;
  Fl_Button *b2;

  {
    Fl_Window* o = new Fl_Window(330, 100, "Enter password");
    w = o;
    w->set_modal();
    o->box(FL_UP_BOX);
  }
  w->begin();
  {
    Fl_Input* o = new Fl_Input(90, 20, 100, 30, "Password:");
    o->type(5);
    i = o;
  }
  {
   Fl_Return_Button* o = new Fl_Return_Button(230, 10, 90, 30, "OK");
   // o->shortcut("^M");
   b1 = o;
  }
  {
   Fl_Button* o = new Fl_Button(230, 50, 90, 30, "Cancel");
   o->shortcut("^[");
   b2 = o;
  }
  w->end();

  i->value("");
  w->hotspot(i);
  w->show();
  int r;
  while (1) {
    Fl_Object *o = Fl::readqueue();
    if (!o) Fl::wait();
    else if (o == b1) { r=0; break; }
    else if (o == b2) { r=1; break; }
    else if (o == w) { r=0; break; }
  }
  w->hide();

  char *str = NULL;

  if (r==0) str=strdup(i->value());
  i->value("");
  delete w;

  return str;
}
